#include "otp_interface.h"

#include <stdio.h>

//g++ test.cpp -L. -letotpverify -o test

/********************************************************************
   
    TOTP JAVA SAMPLE RESULT:
    Secret = 0x3132333435363738393031323334353637383930
    T0 = UTC EPOCH
    X = 30

    +------------+-----------------------+------------------+--------+
    | Unix Time  |       UTC Time        |    Value of T    |  OTP   |
    +------------+-----------------------+------------------+--------+
    | 1000000000 |  2001-09-09 01:46:40  | 0000000001FCA055 | 864010 |
    +------------+-----------------------+------------------+--------+
    | 1111111111 |  2005-03-18 01:58:31  | 00000000023523ED | 050471 |
    +------------+-----------------------+------------------+--------+
    | 1234567890 |  2009-02-13 23:31:30  | 000000000273EF07 | 005924 |
    +------------+-----------------------+------------------+--------+
    | 2000000000 |  2033-05-18 03:33:20  | 0000000003F940AA | 279037 |
    +------------+-----------------------+------------------+--------+
 *******************************************************************/

int main(int argc, char *argv[])
{
	char authkey[51] = "ll598C28E54BF3C58EC35E830655A139861407519FCBC92140";
	uint64_t authnum = 0;
    uint64_t currsucc = 0;
    int currdft = 0;

	
    //TOTP֤
    if (ET_CheckPwdz201(authkey, 1000000000, 0, 60, 0, 20, 0, 
        "864010", 6, &currsucc, &currdft) == OTP_SUCCESS)
    {
        printf("C200 OTP verify ok, currsucc: %llu, currdft: %d\n", 
            currsucc, currdft);        
    }
    else
    {
        printf("C200 OTP verify failed\n");
    }

    //TOTPͬ
    if (ET_Syncz201(authkey, 1000000900, 0, 60, 0, 40, 0, 
            "338666", 6, "365080", 6, &currsucc, &currdft) == OTP_SUCCESS)
    {
        printf("C200 OTP sync ok, currsucc: %llu, currdft: %d\n", 
                currsucc, currdft);
    }
    else
    {
        printf("C200 OTP sync failed\n");
    }

	return 0;
}

